<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Import Datatable sau jquery -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container">
    <div class="text-center mt-4 mb-3">
      <h2>F100 - QUẢN TRỊ NGƯỜI DÙNG</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group mb-0">
        <div class="col-sm-3">
          <label for="voucherCodeInput">Role</label>
        </div>
        <div class="col-sm-6">
          <select id="roleSelect" class="form-control"></select>
        </div>
        <div class="col-sm-3">
          <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead class="thead-dark">
        <tr>
          <th scope='col'>STT</th>
          <th scope='col'>Username</th>
          <th scope='col'>First name</th>
          <th scope='col'>Last name</th>
          <th scope='col'>Email</th>
          <th scope='col'>Age</th>
          <th scope='col'>Role</th>
          <th scope='col'>Action</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
  </div>
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Mảng gUserObjects là mảng chứa dữ liệu users
    var gUserObjects = [
      {
        id: 2,
        username: "quannv",
        firstname: "Ngo Van",
        lastname: "Quan",
        age: 18,
        email: "quan@gmail.com",
        roleId: 5
      },
      {
        id: 3,
        username: "longdh",
        firstname: "Do Hoang",
        lastname: "Long",
        age: 19,
        email: "long@gmail.com",
        roleId: 8
      },
      {
        id: 4,
        username: "hiendt",
        firstname: "Do Thi",
        lastname: "Hien",
        age: 29,
        email: "hien@gmail.com",
        roleId: 11
      },
      {
        id: 6,
        username: "lanht",
        firstname: "Ho Thi",
        lastname: "Lan",
        age: 27,
        email: "lan@gmail.com",
        roleId: 13
      }
    ];
    // Mảng gRoleObjects là mảng chứa dữ liệu các roles
    var gRoleObjects = [
      {
        roleId: 5,
        roleName: "Admin"
      },
      {
        roleId: 8,
        roleName: "Manager"
      },
      {
        roleId: 11,
        roleName: "Teacher"
      },
      {
        roleId: 13,
        roleName: "Staff"
      }
    ];

    var gNameCol = [
      "stt",
      "username",
      "firstname",
      "lastname",
      "email",
      "age",
      "roleId",
      "action"
    ];
    const gSTT_COL = 0;
    const gUSER_NAME_COL = 1;
    const gFIRST_NAME_COL = 2;
    const gLAST_NAME_COL = 3;
    const gEMAIL_COL = 4;
    const gAGE_COL = 5;
    const gROLE_COL = 6;
    const gACTION_COL = 7;


    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
    });

    //gán sự kiện cho nút Filter Role
    $("#btn-filter-role").on("click", function () {
      onBtnFilterRoleClick();
    })

    //gán sự kiện cho nút Dice History
    $("#dice-history").on("click", function () {
      onBtnDiceHistoryClick();
    })

    //gán sự kiện cho nút Voucher History
    $("#voucher-history").on("click", function () {
      onBtnVoucherHistoryClick();
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện filter order
    function onBtnFilterRoleClick() {
      //khai báo đối tượng chứa dữ liệu filter
      var vFilterRoleId = {
        roleId: -1
      };
      //B1: thu thap du lieu de filter
      getFilterFormData(vFilterRoleId);
      //B2: validate data
      //B3: xu ly filter
      filterRoles(vFilterRoleId);
    }
    //hàm xử lý khi load trang
    function onPageLoading() {
      loadDataToRoleSelect();
      showTableUserDataTable();
      $('[data-toggle="tooltip"]').tooltip();
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function onBtnVoucherHistoryClick(paramDataRow) {
      //xử lý chuyển trang sang Trang voucherHistory.html
      const vDETAIL_FORM_URL = "voucherHistory.html"
      var vUrlSiteToOpen = vDETAIL_FORM_URL +
        "?user_name=" + paramDataRow.username +
        "&first_name=" + paramDataRow.firstname +
        "&last_name=" + paramDataRow.lastname;
      location.href = vUrlSiteToOpen;
    }

    function onBtnDiceHistoryClick(paramDataRow) {
      //xử lý chuyển trang sang Trang diceHistory.html
      const vDETAIL_FORM_URL = "diceHistory.html"
      var vUrlSiteToOpen = vDETAIL_FORM_URL +
        "?user_name=" + paramDataRow.username +
        "&first_name=" + paramDataRow.firstname +
        "&last_name=" + paramDataRow.lastname;
      location.href = vUrlSiteToOpen;
    }
    //hàm thực hiện lọc và hiển thị lên table
    function filterRoles(paramFilterFormObj) {
      var vRoleResult = [];
      //thực hiện việc lọc
      //debugger
      vRoleResult = gUserObjects.filter(function (paramOrder) {
        return (paramFilterFormObj.roleId === 0 || paramOrder.roleId === paramFilterFormObj.roleId);
      });
      console.log(vRoleResult);
      //load dữ liệu sau khi filter trả về table
      loadRolesToTable(vRoleResult);
    }

    //hàm thu thập dữ liệu để lọc
    function getFilterFormData(paramFilterFormObj) {
      paramFilterFormObj.roleId = parseInt($("#roleSelect").val(), 10);
      console.log("paramFilterFormObj.roleId: " + paramFilterFormObj.roleId);
    }

    //hàm load dữ liệu vào order table
    function loadRolesToTable(paramOrderArray) {
      $("#user-table").DataTable().clear();
      $("#user-table").DataTable().rows.add(paramOrderArray);
      $("#user-table").DataTable().draw();
    }




    function mappingRoleNameByID(paramData, paramType, paramRow) {
      for (let bI = 0; bI < gRoleObjects.length; bI++) {
        const bRoleObjItem = gRoleObjects[bI];
        if (paramData == bRoleObjItem.roleId) {
          return bRoleObjItem.roleName;
        }
      }
    }

    function loadDataToRoleSelect() {
      var vRoleSelect = $("#roleSelect");
      $("<option/>", {
        text: "--- Chọn tất cả ---",
        value: 0
      }).appendTo(vRoleSelect);

      for (let bI = 0; bI < gRoleObjects.length; bI++) {
        var bPizzaTypeOption = $("<option/>", {
          text: gRoleObjects[bI].roleName,
          value: gRoleObjects[bI].roleId
        }).appendTo(vRoleSelect);
      }
    }
    function showTableUserDataTable() {
      console.log(gUserObjects);
      $("#user-table").DataTable({
        data: gUserObjects,
        columns: [
          { data: gNameCol[gSTT_COL] },
          { data: gNameCol[gUSER_NAME_COL] },
          { data: gNameCol[gFIRST_NAME_COL] },
          { data: gNameCol[gLAST_NAME_COL] },
          { data: gNameCol[gEMAIL_COL] },
          { data: gNameCol[gAGE_COL] },
          { data: gNameCol[gROLE_COL] },
          { data: gNameCol[gACTION_COL] }
        ], // Các thuộc tính của USER sẽ  match với từng column
        columnDefs: [
          //định nghĩa các cột cần hiện ra
          {
            targets: gSTT_COL, //cột STT
            className: "text-center text-primary",
            render: function (data, type, row, meta) {
              return meta.row + meta.settings._iDisplayStart + 1;
            }
          },
          {
            targets: gROLE_COL,
            className: "text-right",
            render: mappingRoleNameByID
          },
          {
            targets: gACTION_COL, //cột Action
            className: "text-center",
            defaultContent: `
            <button id="dice-history" class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
            <button id="voucher-history" class="btn btn-link btn-sm" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>`
          }
        ]
      });
    }

  </script>
</body>

</html>